unit uMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, MSXML2_TLB, Menus, ExtCtrls, ComCtrls, ComObj, StdCtrls, uCesty,
  uOptimalne, uOptfrm;

const
  Meritko = 2;

type
  TForm1 = class(TForm)
    odOtevriMapu: TOpenDialog;
    MainMenu1: TMainMenu;
    Soubor1: TMenuItem;
    Otevt1: TMenuItem;
    ScrollBox1: TScrollBox;
    imgMapa: TImage;
    Nastaven1: TMenuItem;
    miCesty: TMenuItem;
    miVybrana: TMenuItem;
    sdUlozit: TSaveDialog;
    Nstroje1: TMenuItem;
    Ukzatcesty1: TMenuItem;
    Optimlntrasa1: TMenuItem;
    Uloit1: TMenuItem;
    Konec1: TMenuItem;
    procedure Otevt1Click(Sender: TObject);
    procedure miCestyClick(Sender: TObject);
    procedure miVybranaClick(Sender: TObject);
    procedure Ukzatcesty1Click(Sender: TObject);
    procedure Optimlntrasa1Click(Sender: TObject);
    procedure Uloit1Click(Sender: TObject);
    procedure Konec1Click(Sender: TObject);
  private
    { Private declarations }
  public
    Mapa: IXMLDOMDocument;
    PosunX, PosunY: Integer;
    VelikostX, VelikostY: Integer;
    VybranaCesta: TList;
    procedure ZjistiVelikost;
    procedure KresliMesto(Mesto: IXMLDOMNode);
    procedure KresliMesta;
    procedure KresliCesty;
    procedure KresliCestu(Cesta: IXMLDOMNode);
    Procedure Kresli;
    procedure KresliVybranouCestu(Mesta: TList);
    procedure UlozVybranou(const JmenoSouboru: string);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Otevt1Click(Sender: TObject);
begin
  if odOtevriMapu.Execute then
  begin
    Mapa := CreateComObject(CLASS_DOMDocument) as IXMLDomDocument;
    Mapa.load(odOtevriMapu.FileName);
    ZjistiVelikost;
    imgMapa.Width := VelikostX * Meritko;
    imgMapa.Height := VelikostY * Meritko;
    Kresli;
  end;
end;

procedure TForm1.ZjistiVelikost;
var
  elements: IXMLDOMNodeList;
  Min, Max: Integer;

procedure ZjistiMinMax;
var
  i, Value: Integer;
begin
  Min := MaxInt;
  Max := -MaxInt;
  for i := 0 to elements.length - 1 do
  begin
    Value := elements.item[i].nodeTypedValue;
    if Value < Min then
      Min := Value;
    if Value > Max then
      Max := Value;
  end;
end;

begin
  elements := Mapa.selectNodes('//polohaX');
  ZjistiMinMax;
  PosunX := Min - 10;
  VelikostX := Max - Min + 20;
  elements := Mapa.selectNodes('//polohaY');
  ZjistiMinMax;
  PosunY := Min - 10;
  VelikostY := Max - Min + 20;
end;

procedure TForm1.KresliMesto(Mesto: IXMLDomNode);
var
  X, Y: Integer;
  Nazev: string;
  cnv: TCanvas;
begin
  cnv := imgMapa.Canvas;
  cnv.Pen.Color := clBlack;  
  X := (Mesto.selectSingleNode('polohaX').nodeTypedValue - PosunX) * Meritko;
  Y := (Mesto.selectSingleNode('polohaY').nodeTypedValue - PosunY) * Meritko;
  Nazev := Mesto.selectSingleNode('nazev').nodeTypedValue;
  cnv.Ellipse(X - 2, Y - 2, X + 2, Y + 2);
  cnv.TextOut(X + 10, Y, Nazev);
end;

procedure TForm1.KresliMesta;
var
  elements: IXMLDOMNodeList;
  i: Integer;
begin
  elements := Mapa.selectNodes('//mesto');
  for i := 0 to elements.length - 1 do
    KresliMesto(elements.item[i]);
end;

procedure TForm1.KresliCesty;
var
  elements: IXMLDOMNodeList;
  i: Integer;
begin
  elements := Mapa.selectNodes('//cesta');
  for i := 0 to elements.length - 1 do
    KresliCestu(elements.item[i]);
end;

procedure TForm1.KresliCestu(Cesta: IXMLDOMNode);
var
  MestoZ, MestoDo: IXMLDomNode;
  ZX, ZY, DoX, DoY: Integer;
  s: string;
begin
  imgMapa.Canvas.Pen.Color := clBlack;
  s := Cesta.selectSingleNode('z').nodeTypedValue;
  MestoZ := Mapa.selectSingleNode(Format('mapa/mesta/mesto[nazev="%s"]', [s]));
  s := Cesta.selectSingleNode('do').nodeTypedValue;
  MestoDo := Mapa.selectSingleNode(Format('mapa/mesta/mesto[nazev="%s"]', [s]));
  ZX := (MestoZ.selectSingleNode('polohaX').nodeTypedValue - PosunX) * Meritko;
  ZY := (MestoZ.selectSingleNode('polohaY').nodeTypedValue - PosunY) * Meritko;
  DoX := (MestoDo.selectSingleNode('polohaX').nodeTypedValue - PosunX) * Meritko;
  DoY := (MestoDo.selectSingleNode('polohaY').nodeTypedValue - PosunY) * Meritko;
  imgMapa.Canvas.MoveTo(ZX, ZY);
  imgMapa.Canvas.LineTo(DoX, DoY);
end;

procedure TForm1.miCestyClick(Sender: TObject);
begin
  Kresli;
end;

procedure TForm1.Kresli;
begin
  imgMapa.Canvas.FillRect(Rect(0, 0, imgMapa.Width, imgMapa.Height));
  KresliMesta;
  if miCesty.Checked then
    KresliCesty;
  if miVybrana.Checked then
    KresliVybranouCestu(VybranaCesta);
end;

procedure TForm1.KresliVybranouCestu(Mesta: TList);
var
  i: Integer;
  mestoZ, mestoDo: IXMLDomNode;
  ZX, ZY, DoX, DoY: Integer;
begin
  if Mesta <> nil then
  begin
    imgMapa.Canvas.Pen.Color := clRed;
    for i := 0 to Mesta.Count - 2 do
    begin
      mestoZ := Mapa.selectSingleNode(Format('//mesto[nazev="%s"]', [TMesto(Mesta[i]).Nazev]));
      mestoDo := Mapa.selectSingleNode(Format('//mesto[nazev="%s"]', [TMesto(Mesta[i + 1]).Nazev]));
      ZX := (mestoZ.selectSingleNode('polohaX').nodeTypedValue - PosunX) * Meritko;
      ZY := (mestoZ.selectSingleNode('polohaY').nodeTypedValue - PosunY) * Meritko;
      DoX := (mestoDo.selectSingleNode('polohaX').nodeTypedValue - PosunX) * Meritko;
      DoY := (mestoDo.selectSingleNode('polohaY').nodeTypedValue - PosunY) * Meritko;
      imgMapa.Canvas.MoveTo(ZX, ZY);
      imgMapa.Canvas.LineTo(DoX, DoY);
    end;
  end;
end;

procedure TForm1.miVybranaClick(Sender: TObject);
begin
  Kresli;
end;

procedure TForm1.UlozVybranou;
var
  elm: IXMLDOMNode;
  i: Integer;
begin
  with CreateComObject(CLASS_DOMDocument) as IXMLDomDocument do
  begin
    documentElement := createElement('cesta');
    elm := createElement('z');
    elm.nodeTypedValue := TMesto(VybranaCesta[0]).Nazev;
    documentElement.appendChild(elm);
    elm := createElement('do');
    elm.nodeTypedValue := TMesto(VybranaCesta[VybranaCesta.Count - 1]).Nazev;
    documentElement.appendChild(elm);
    for i := 1 to VybranaCesta.Count - 2 do
    begin
      elm := createElement('pres');
      elm.nodeTypedValue := TMesto(VybranaCesta[i]).Nazev;
      documentElement.appendChild(elm);
    end;
    save(JmenoSouboru);
  end;
end;

procedure TForm1.Ukzatcesty1Click(Sender: TObject);
begin
  with TfCesty.Create(nil) do
  begin
    CestyMapa := Mapa;
    ShowModal;
    Release;
  end;
end;

procedure TForm1.Optimlntrasa1Click(Sender: TObject);
begin
  with TfOptFrm.Create(nil) do
  begin
    OptMapa := Mapa;
    if ShowModal = mrOK then
    begin
      with TMesta.Create(Mapa) do
      begin
        VybranaCesta.Free;
        Nacti;
        MestoPodleJmena(lsZ.Items[lsZ.ItemIndex]).Hledane := True;
        MestoPodleJmena(lsDo.Items[lsDo.ItemIndex]).HledejCestu(0, TKriterium(rgKriterium.ItemIndex));
        VybranaCesta := Cesta;
        miVybrana.Checked := True;
        Kresli;
        Free;
      end;
    end;
    Release;
  end;
end;

procedure TForm1.Uloit1Click(Sender: TObject);
begin
  if (VybranaCesta = nil) or (VybranaCesta.Count = 0) then
  begin
    ShowMessage('Nen co ukldat');
    Exit;
  end;
  if sdUlozit.Execute then
  begin
    UlozVybranou(sdUlozit.FileName);
  end;
end;

procedure TForm1.Konec1Click(Sender: TObject);
begin
  Close;
end;

end.
